<script setup lang="ts">
import { computed, nextTick, onMounted } from 'vue'
import { ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { type Employee } from '@/types/Employee'

const initialEmployee: Employee = {
  id: -1,
  name: '',
  email: '',
  tel: '',
  password: '',
  gender: 'male',
  roles: ['manager']
}
const search = ref('')
const filteredEmployee = computed(() => {
  return employees.value.filter((employees) =>
    employees.name.toUpperCase().includes(search.value.toUpperCase())
  )
})

const editedEmployee = ref<Employee>(JSON.parse(JSON.stringify(initialEmployee)))
const employees = ref<Employee[]>([])
let editedIndex = -1
let lastId = 6
const itemsPerPage = ref<any>(10)
const page = ref(1)
const pageCount = computed(() => {
  return Math.ceil(employees.value.length / itemsPerPage.value)
})
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Email',
    key: 'email',
    value: 'email'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  {
    title: 'Gender',
    key: 'gender',
    value: 'gender'
  },
  {
    title: 'Roles',
    key: 'roles',
    value: (item: any | Employee) => item.roles.join(', ')
  },
  { title: '', key: 'actions', sortable: false }
]
function initialize() {
  employees.value = [
    {
      id: 1,
      name: 'manager',
      email: 'managerMail',
      tel: '0987654321',
      password: 'pass@word123',
      gender: 'female',
      roles: ['manager', 'staff']
    },
    {
      id: 2,
      name: 'kanoknapas',
      email: 'managerMail2',
      tel: '0987653466',
      password: 'pass@word123',
      gender: 'male',
      roles: ['manager', 'staff']
    },
    {
      id: 3,
      name: 'staff',
      email: 'staffMail',
      tel: '0987634876',
      password: 'pass@word123',
      gender: 'female',
      roles: ['staff']
    },
    {
      id: 4,
      name: 'top',
      email: 'staffMail2',
      tel: '0987947455',
      password: 'pass@word123',
      gender: 'male',
      roles: ['staff']
    },
    {
      id: 5,
      name: 'staff3',
      email: 'staffMail3',
      tel: '0987653466',
      password: 'pass@word123',
      gender: 'female',
      roles: ['staff']
    }
  ]
}
onMounted(() => {
  initialize()
})

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedEmployee.value = Object.assign({}, initialEmployee)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(employees.value[editedIndex], editedEmployee.value)
  } else {
    editedEmployee.value.id = lastId++
    employees.value.push(editedEmployee.value)
  }
  closeDialog()
}

function onSubmit() {}

function editItem(item: Employee) {
  editedIndex = employees.value.indexOf(item)
  editedEmployee.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: Employee) {
  editedIndex = employees.value.indexOf(item)
  editedEmployee.value = Object.assign({}, item)
  dialogDelete.value = true
}

function deleteItemConfirm() {
  employees.value.splice(editedIndex, 1)
  closeDelete()
  editedIndex = -1
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedEmployee.value = Object.assign({}, initialEmployee)
  })
}
</script>

<template>
  <div style="width: 95%; height: 100%; margin-top: 5%">
    <v-data-table
      v-model:page="page"
      :headers="headers"
      :items="filteredEmployee"
      :items-per-page="itemsPerPage"
    >
      <template v-slot:top>
        <v-toolbar flat color="#F48FB1">
          <v-toolbar-title>
            <v-icon icon="mdi-account"></v-icon>
            Employee
          </v-toolbar-title>

          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn color="#ECEFF1" v-bind="props" variant="flat">
                <v-icon icon="mdi-plus" size="large"></v-icon>
                New Employee
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">New Employee</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedEmployee.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedEmployee.email"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required', (v) => /.+@.+\..+/.test(v)]"
                          class="mb-2"
                          clearable
                          label="Email"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="editedEmployee.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required', (v) => !/[^0-9]/g.test(v)]"
                          clearable
                          label="Tel"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="editedEmployee.password"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Password"
                          placeholder="Enter your password"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="6">
                        <v-combobox
                          label="Gender"
                          :items="['male', 'famale', 'others']"
                          v-model="editedEmployee.gender"
                        ></v-combobox>
                      </v-col>

                      <v-col cols="12" sm="6">
                        <v-combobox
                          v-model="editedEmployee.roles"
                          :items="[
                            { title: 'Manager', value: 'manager' },
                            { title: 'Staff', value: 'staff' }
                          ]"
                          label="Roles"
                          multiple
                          :return-object="false"
                        ></v-combobox>
                      </v-col>
                    </v-row>
                  </v-container>

                  <br />
                </v-form>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="red" variant="flat" @click="closeDialog()"> Close </v-btn>
                <v-btn color="green" variant="flat" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-text-field
            v-model="search"
            prepend-inner-icon="mdi-magnify"
            density="compact"
            label="Search"
            single-line
            flat
            hide-details
            variant="outlined"
            style="margin-right: 20px"
          ></v-text-field>
        </v-toolbar>
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <br />
            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title
            ><br />
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" variant="flat" width="80px" @click="closeDelete">Cancel</v-btn>
              <v-btn color="green" variant="flat" width="80px" @click="deleteItemConfirm">OK</v-btn>
              <v-spacer></v-spacer>
            </v-card-actions>
            <br />
          </v-card>
        </v-dialog>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize"> Reset </v-btn>
      </template>
      <template v-slot:bottom>
        <div class="text-center pt-2">
          <v-pagination v-model="page" :length="pageCount"></v-pagination>
        </div>
      </template>
    </v-data-table>
  </div>
</template>
